package nz.ac.canterbury.debugassist.model;

import java.util.Date;


public class BreakpointEvent {

	private Date timeHit;

	private int numHit;

	private String threadName;

	private String stackName;

	private Variable[] variables;
	
	public BreakpointEvent(Date timeHit, int numHit, String threadName, String stackName, Variable[] variables) {
		this.timeHit = timeHit;
		this.numHit = numHit;
		this.threadName = threadName;
		this.stackName = stackName;
		this.variables = variables;
	}
	
	public Variable[] getVariables() {
		return variables;
	}

	public String getStackName() {
		return stackName;
	}
	

	public int getNumHit() {
		return numHit;
	}
	
	
	public Date getTimeHit() {
		return timeHit;
	}

	
	public String getThreadName() {
		return threadName;
	}
	public String toString() {
		return "Breakpoint: " + numHit;
	}
	
	public void updateVariables(Variable[] vars) {
		this.variables = vars;
	}
	
}
