package nz.ac.canterbury.debugassist.model;
import java.util.ArrayList;
import java.util.HashMap;

import org.eclipse.debug.core.*;
import org.eclipse.debug.core.model.*;
public class ModelGenerator {
	ArrayList<Variable> root;
	HashMap<IVariable, Variable> map;
	
	private ModelGenerator(IVariable[] vars) {
		map = new HashMap<IVariable, Variable>();
		 root = new ArrayList<Variable>();
			for(IVariable child : vars) {
				root.add(generate(child));
			}
			
	}
	
	private Variable[] getArray() {
		return (Variable[]) (root.toArray(new Variable[0]));
	}
	
	
	public static Variable[] generate(IVariable[] vars) {
		ModelGenerator model = new ModelGenerator(vars);

	
		
		return model.getArray();
	}
	private Variable generate(IVariable var) {
		Variable root = null;
		try {
			
			root = new Variable(var.getReferenceTypeName(), var.getName(), var.getValue().getValueString(), false, var.hasValueChanged());
			map.put(var, root);
			for(IVariable child :  var.getValue().getVariables()) {
				if(map.containsKey(child)) {
					root.addVariable(map.get(child));
				} else {
					root.addVariable(generate(child));
				}
				
			}
		} catch (DebugException ex){

		}
		return root;
	}
}
